TEMPLATE = lib
TARGET  = terralib
CONFIG	= warn_on dll rtti

isEmpty(TE_PROJECT_TYPE) {
  TE_PROJECT_TYPE=RELEASE
}

contains(TE_PROJECT_TYPE , DEBUG) {
  CONFIG += debug
}

contains(TE_PROJECT_TYPE , RELEASE) {
  CONFIG += release
}

unix {
  release {
    DEFINES += NDEBUG
    OBJECTS_DIR = ../Release/.obj/terralib
    DESTDIR = ../Release
    LIBS += -L../Release
  }

  debug {
    DEFINES += _DEBUG
    OBJECTS_DIR = ../Debug/.obj/terralib
    DESTDIR = ../Debug
    LIBS += -L../Debug
  }

  LIBS += -lpthread -lz -ljpeg -lterralibtiff
}

SOURCES	+=	\
			../../src/terralib/kernel/lexTemporal.cpp \
			../../src/terralib/kernel/TeAbstractTheme.cpp \
			../../src/terralib/kernel/TeAffineGT.cpp \
			../../src/terralib/kernel/TeAffineGTFactory.cpp \
			../../src/terralib/kernel/TeAgnostic.cpp \
			../../src/terralib/kernel/TeAsciiFile.cpp \
			../../src/terralib/kernel/TeBox.cpp \
			../../src/terralib/kernel/TeBufferRegion.cpp \
			../../src/terralib/kernel/TeCentroid.cpp \
			../../src/terralib/kernel/TeComputeAttributeStrategies.cpp \
			../../src/terralib/kernel/TeDatabase.cpp \
			../../src/terralib/kernel/TeDatabaseFactory.cpp \
			../../src/terralib/kernel/TeDatum.cpp \
			../../src/terralib/kernel/TeDBConnectionsPool.cpp \
			../../src/terralib/kernel/TeDecoderASCIIGrid.cpp \
			../../src/terralib/kernel/TeDecoderDatabase.cpp \
			../../src/terralib/kernel/TeDecoderFile.cpp \
			../../src/terralib/kernel/TeDecoderJPEG.cpp \
			../../src/terralib/kernel/TeDecoderMemory.cpp \
			../../src/terralib/kernel/TeDecoderMemoryMap.cpp \
			../../src/terralib/kernel/TeDecoderSPR.cpp \
			../../src/terralib/kernel/TeDecoderTIFF.cpp \
			../../src/terralib/kernel/TeDecoderVirtualMemory.cpp \
			../../src/terralib/kernel/TeDecoderSmartMem.cpp \
			../../src/terralib/kernel/TeErrorLog.cpp \
			../../src/terralib/kernel/TeErrorMessage.cpp \
			../../src/terralib/kernel/TeException.cpp \
			../../src/terralib/kernel/TeExternalTheme.cpp \
			../../src/terralib/kernel/TeFragmentation.cpp \
			../../src/terralib/kernel/TeFileTheme.cpp \	
			../../src/terralib/kernel/TeGeometricTransformation.cpp \
			../../src/terralib/kernel/TeGeometry.cpp \
			../../src/terralib/kernel/TeGeometryAlgorithms.cpp \
			../../src/terralib/kernel/TeGTParams.cpp \
			../../src/terralib/kernel/TeGTFactory.cpp \
			../../src/terralib/kernel/TeGroupingAlgorithms.cpp \
			../../src/terralib/kernel/TeImportRaster.cpp \
			../../src/terralib/kernel/TeInitRasterDecoders.cpp \
			../../src/terralib/kernel/TeIntersector.cpp \
			../../src/terralib/kernel/TeLayer.cpp \
			../../src/terralib/kernel/TeLegendEntry.cpp \
			../../src/terralib/kernel/TeMatrix.cpp \
			../../src/terralib/kernel/TeMetaModelCache.cpp \
			../../src/terralib/kernel/TeMultiGeometry.cpp \
			../../src/terralib/kernel/TeNeighbours.cpp \
			../../src/terralib/kernel/TeNetwork.cpp \
			../../src/terralib/kernel/TeOverlay.cpp \
			../../src/terralib/kernel/TeOverlayUtils.cpp \
			../../src/terralib/kernel/TeProgress.cpp \
			../../src/terralib/kernel/TeProject.cpp \
			../../src/terralib/kernel/TeProjection.cpp \
			../../src/terralib/kernel/TeProjectiveGT.cpp \
			../../src/terralib/kernel/TeProjectiveGTFactory.cpp \
			../../src/terralib/kernel/TeProxMatrixConstructionStrategy.cpp \
			../../src/terralib/kernel/TeProxMatrixImplementation.cpp \
			../../src/terralib/kernel/TeProxMatrixStrategies.cpp \
			../../src/terralib/kernel/TeQuerier.cpp \
			../../src/terralib/kernel/TeQuerierDB.cpp \
			../../src/terralib/kernel/TeQuerierDBStr1.cpp \
			../../src/terralib/kernel/TeQuerierDBStr2.cpp \
			../../src/terralib/kernel/TeQuerierDBStr3.cpp \
			../../src/terralib/kernel/TeQuerierImpl.cpp \
			../../src/terralib/kernel/TeQuerierParams.cpp \
			../../src/terralib/kernel/TeRaster.cpp \
			../../src/terralib/kernel/TeRasterParams.cpp \
			../../src/terralib/kernel/TeRasterRemap.cpp \
			../../src/terralib/kernel/TeRasterTransform.cpp \
			../../src/terralib/kernel/TeRepresentation.cpp \
			../../src/terralib/kernel/TeSpatialOperations.cpp \
			../../src/terralib/kernel/TeStdFile.cpp \
			../../src/terralib/kernel/TeSTElementSet.cpp \
			../../src/terralib/kernel/TeSTEvent.cpp \
			../../src/terralib/kernel/TeSTInstance.cpp \
			../../src/terralib/kernel/TeTable.cpp \
			../../src/terralib/kernel/TeTemporalSeries.cpp \
			../../src/terralib/kernel/TeTheme.cpp \
			../../src/terralib/kernel/TeTime.cpp \
			../../src/terralib/kernel/TeTimeInterval.cpp \
			../../src/terralib/kernel/TeTin.cpp \
			../../src/terralib/kernel/TeUtils.cpp \
			../../src/terralib/kernel/TeVectorRemap.cpp \
			../../src/terralib/kernel/TeViewNode.cpp \
			../../src/terralib/kernel/TeVisual.cpp \
			../../src/terralib/kernel/yyTemporal.cpp \
			../../src/terralib/kernel/TeDatabaseFactoryParams.cpp \
			../../src/terralib/kernel/TeMappedMemory.cpp \
			../../src/terralib/kernel/TeRasterMemManager.cpp \
			../../src/terralib/kernel/TeMutex.cpp \
			../../src/terralib/kernel/TeThread.cpp \
      ../../src/terralib/kernel/TeThreadFunctor.cpp \   
      ../../src/terralib/kernel/TeThreadSignal.cpp \
			../../src/terralib/drivers/libjpeg/TeLibJpegWrapper.cpp \
			../../src/terralib/drivers/libjpeg/jmemdst.c \
			../../src/terralib/drivers/libjpeg/jmemsrc.c \
      ../../src/terralib/kernel/TeStdIOProgress.cpp \
      ../../src/terralib/kernel/TeThreadJobsManager.cpp \
      ../../src/terralib/kernel/TeThreadJob.cpp \
      ../../src/terralib/kernel/TeFunctionCallThreadJob.cpp \
      ../../src/terralib/kernel/TeTempFilesRemover.cpp

HEADERS	+= 	../../src/terralib/kernel/checkvec.h \
			../../src/terralib/kernel/dynpq.h \
			../../src/terralib/kernel/Gra_algo.h \
			../../src/terralib/kernel/graph.h \
			../../src/terralib/kernel/TeAbstractFactory.h \
			../../src/terralib/kernel/TeAbstractTheme.h \
			../../src/terralib/kernel/TeAffineGT.h \
			../../src/terralib/kernel/TeAffineGTFactory.h \
			../../src/terralib/kernel/TeAgnostic.h \
			../../src/terralib/kernel/TeAsciiFile.h \
			../../src/terralib/kernel/TeAttribute.h \
			../../src/terralib/kernel/TeBox.h \
			../../src/terralib/kernel/TeBufferRegion.h \
			../../src/terralib/kernel/TeComposite.h \
			../../src/terralib/kernel/TeCommunicator.h \      
			../../src/terralib/kernel/TeComputeAttributeStrategies.h \
			../../src/terralib/kernel/TeCoord2D.h \
			../../src/terralib/kernel/TeCounted.h \
			../../src/terralib/kernel/TeDatabase.h \
			../../src/terralib/kernel/TeDataTypes.h \
			../../src/terralib/kernel/TeDatum.h \
			../../src/terralib/kernel/TeDBConnectionsPool.h \
			../../src/terralib/kernel/TeDecoder.h \
			../../src/terralib/kernel/TeDecoderASCIIGrid.h \
			../../src/terralib/kernel/TeDecoderDatabase.h \
			../../src/terralib/kernel/TeDecoderFile.h \
			../../src/terralib/kernel/TeDecoderJPEG.h \
			../../src/terralib/kernel/TeDecoderMemory.h \
			../../src/terralib/kernel/TeDecoderMemoryMap.h \
			../../src/terralib/kernel/TeDecoderSPR.h \
			../../src/terralib/kernel/TeDecoderTIFF.h \
			../../src/terralib/kernel/TeDecoderVirtualMemory.h \
			../../src/terralib/kernel/TeDecoderSmartMem.h \
			../../src/terralib/kernel/TeDefines.h \
			../../src/terralib/kernel/TeErrorLog.h \
			../../src/terralib/kernel/TeErrorMessage.h \
			../../src/terralib/kernel/TeException.h \
			../../src/terralib/kernel/TeExternalTheme.h \
			../../src/terralib/kernel/TeFactory.h \
			../../src/terralib/kernel/TeFragmentation.h \
			../../src/terralib/kernel/TeFileTheme.h \	
			../../src/terralib/kernel/TeGeneralizedProxMatrix.h \
			 ../../src/terralib/kernel/TeGeometricTransformation.h \
			../../src/terralib/kernel/TeGeometry.h \
			../../src/terralib/kernel/TeGeometryAlgorithms.h \
			../../src/terralib/kernel/TeGTParams.h \
			../../src/terralib/kernel/TeGTFactory.h \
			../../src/terralib/kernel/TeGroupingAlgorithms.h \
			../../src/terralib/kernel/TeImportRaster.h \
			../../src/terralib/kernel/TeIntersector.h \
			../../src/terralib/kernel/TeLayer.h \
			../../src/terralib/kernel/TeLegendEntry.h \
			../../src/terralib/kernel/TeMatrix.h \
			../../src/terralib/kernel/TeMeasure.h \
			../../src/terralib/kernel/TeMetaModelCache.h \
			../../src/terralib/kernel/TeMultiGeometry.h \
			../../src/terralib/kernel/TeNeighbours.h \
			../../src/terralib/kernel/TeNetwork.h \
			../../src/terralib/kernel/TeOverlay.h \
			../../src/terralib/kernel/TeOverlayUtils.h \
			../../src/terralib/kernel/TePrecision.h \
			../../src/terralib/kernel/TeProgress.h \
			../../src/terralib/kernel/TeProgressBase.h \
			../../src/terralib/kernel/TeProject.h \
			../../src/terralib/kernel/TeProjection.h \
			../../src/terralib/kernel/TeProjectiveGT.h \
			../../src/terralib/kernel/TeProjectiveGTFactory.h \
			../../src/terralib/kernel/TePrototype.h \
			../../src/terralib/kernel/TeProxMatrixConstructionStrategy.h \
			../../src/terralib/kernel/TeProxMatrixImplementation.h \
			../../src/terralib/kernel/TeProxMatrixSlicingStrategy.h \
			../../src/terralib/kernel/TeProxMatrixWeightsStrategy.h \
			../../src/terralib/kernel/TeQuerier.h\
			../../src/terralib/kernel/TeQuerierDB.h\
			../../src/terralib/kernel/TeQuerierDBStr1.h\
			../../src/terralib/kernel/TeQuerierDBStr2.h\
			../../src/terralib/kernel/TeQuerierDBStr3.h \
			../../src/terralib/kernel/TeQuerierImpl.h\
			../../src/terralib/kernel/TeQuerierParams.h\
			../../src/terralib/kernel/TeRaster.h \
			../../src/terralib/kernel/TeRasterParams.h \
			../../src/terralib/kernel/TeRasterRemap.h \
			../../src/terralib/kernel/TeRasterTransform.h \
			../../src/terralib/kernel/TeRedBlackTree.h \
			../../src/terralib/kernel/TeRepresentation.h \
			../../src/terralib/kernel/TeSharedPtr.h \      
			../../src/terralib/kernel/TeSingleton.h \
			../../src/terralib/kernel/TeSlice.h \
			../../src/terralib/kernel/TeSpatialOperations.h \
			../../src/terralib/kernel/TeStatistics.h \
			../../src/terralib/kernel/TeStdFile.h \
			../../src/terralib/kernel/TeSTEFunctionsDB.h \
			../../src/terralib/kernel/TeBaseSTInstance.h \
			../../src/terralib/kernel/TeBaseSTInstanceSet.h \
			../../src/terralib/kernel/TeSTElementSet.h \
			../../src/terralib/kernel/TeSTEvent.h \
			../../src/terralib/kernel/TeSTInstance.h\
			../../src/terralib/kernel/TeTable.h \
			../../src/terralib/kernel/TeTemporalSeries.h \
			../../src/terralib/kernel/TeTheme.h \
			../../src/terralib/kernel/TeTime.h \
			../../src/terralib/kernel/TeTimeInterval.h \
			../../src/terralib/kernel/TeTin.h \
			../../src/terralib/kernel/TeUtils.h \
			../../src/terralib/kernel/TeVectorRemap.h \
			../../src/terralib/kernel/TeView.h \
			../../src/terralib/kernel/TeViewNode.h \
			../../src/terralib/kernel/TeVisual.h \
			../../src/terralib/kernel/yyTemporal.h \
			../../src/terralib/kernel/TeRasterMemManager.h \
			../../src/terralib/kernel/TeMutex.h \
			../../src/terralib/kernel/TeThreadParameters.h \
			../../src/terralib/kernel/TeThread.h \
      ../../src/terralib/kernel/TeThreadFunctor.h \   
      ../../src/terralib/kernel/TeThreadSignal.h \
			../../src/terralib/kernel/TeDatabaseFactoryParams.h \
			../../src/terralib/kernel/TeMappedMemory.h \
			../../src/terralib/drivers/libjpeg/TeLibJpegWrapper.h \
			../../src/terralib/drivers/libjpeg/jmemdstsrc.h \
			../../src/terralib/kernel/TeMultiContainer.h \
      ../../src/terralib/kernel/TeStdIOProgress.h \
      ../../src/terralib/kernel/TeThreadJobsManager.h \
      ../../src/terralib/kernel/TeThreadJob.h \
      ../../src/terralib/kernel/TeFunctionCallThreadJob.h \
      ../../src/terralib/kernel/TeTempFilesRemover.h          

INCLUDEPATH	= \
      ../../src/terralib/kernel \
			../../src/terralib/functions \
			../../src/terralib/utils \
			../../src/tiff \
			../../src/zlib \
			../../src/terralib/drivers/libjpeg \
      $$INCLUDEPATH

